Index: src/atom.cpp
===================================================================
--- src/atom.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/atom.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -13,21 +13,40 @@
 atom::atom()
 {
-	Name = NULL;
-	previous = NULL;
-	next = NULL;
-	father = this;	// generally, father is itself
-	Ancestor = NULL;
-	type = NULL;
-	sort = NULL;
-	FixedIon = 0;
-	nr = -1;
-	GraphNr = -1;
-	ComponentNr = NULL;
-	IsCyclic = false;
-	SeparationVertex = false;
-	LowpointNr = -1;
-	AdaptiveOrder = 0;
-	MaxOrder = false;
+  Name = NULL;
+  previous = NULL;
+  next = NULL;
+  father = this;  // generally, father is itself
+  Ancestor = NULL;
+  type = NULL;
+  sort = NULL;
+  FixedIon = 0;
+  nr = -1;
+  GraphNr = -1;
+  ComponentNr = NULL;
+  IsCyclic = false;
+  SeparationVertex = false;
+  LowpointNr = -1;
+  AdaptiveOrder = 0;
+  MaxOrder = false;
 };
+
+/** Constructor of class atom.
+ *
+ */
+atom::atom(atom *pointer)
+{
+  Name = NULL;
+  previous = NULL;
+  next = NULL;
+  father = this;  // generally, father is itself
+  Ancestor = NULL;
+  type = pointer->type;  // copy element of atom
+  x.CopyVector(&pointer->x); // copy coordination
+  v.CopyVector(&pointer->v); // copy velocity
+  FixedIon = pointer->FixedIon;
+  nr = -1;
+  sort = &nr;
+}
+
 
 /** Destructor of class atom.
@@ -35,6 +54,6 @@
 atom::~atom()
 {
-	Free((void **)&Name, "atom::~atom: *Name");
-	Free((void **)&ComponentNr, "atom::~atom: *ComponentNr");
+  Free((void **)&Name, "atom::~atom: *Name");
+  Free((void **)&ComponentNr, "atom::~atom: *ComponentNr");
 };
 
@@ -45,11 +64,11 @@
 atom *atom::GetTrueFather()
 {
-	atom *walker = this;
-	do {
-		if (walker == walker->father) // top most father is the one that points on itself
-			break;
-		walker = walker->father;
-	} while (walker != NULL);
-	return walker;
+  atom *walker = this;
+  do {
+    if (walker == walker->father) // top most father is the one that points on itself
+      break;
+    walker = walker->father;
+  } while (walker != NULL);
+  return walker;
 };
 
@@ -62,17 +81,17 @@
 bool atom::Output(int ElementNo, int AtomNo, ofstream *out, const char *comment) const
 {
-	if (out != NULL) {
-		*out << "Ion_Type" << ElementNo << "_" << AtomNo << "\t"	<< fixed << setprecision(9) << showpoint;
-		*out << x.x[0] << "\t" << x.x[1] << "\t" << x.x[2];
-		*out << "\t" << FixedIon;
-		if (v.Norm() > MYEPSILON)
-			*out << "\t" << scientific << setprecision(6) << v.x[0] << "\t" << v.x[1] << "\t" << v.x[2] << "\t";
-		if (comment != NULL)
-		  *out << " # " << comment << endl;
-		else
-		  *out << " # molecule nr " << nr << endl;
-		return true;
-	} else
-		return false;
+  if (out != NULL) {
+    *out << "Ion_Type" << ElementNo << "_" << AtomNo << "\t"  << fixed << setprecision(9) << showpoint;
+    *out << x.x[0] << "\t" << x.x[1] << "\t" << x.x[2];
+    *out << "\t" << FixedIon;
+    if (v.Norm() > MYEPSILON)
+      *out << "\t" << scientific << setprecision(6) << v.x[0] << "\t" << v.x[1] << "\t" << v.x[2] << "\t";
+    if (comment != NULL)
+      *out << " # " << comment << endl;
+    else
+      *out << " # molecule nr " << nr << endl;
+    return true;
+  } else
+    return false;
 };
 
@@ -82,15 +101,15 @@
 bool atom::OutputXYZLine(ofstream *out) const
 {
-	if (out != NULL) {
-		*out << type->symbol << "\t" << x.x[0] << "\t" << x.x[1] << "\t" << x.x[2] << "\t" << endl;
-		return true;
-	} else
-		return false;
+  if (out != NULL) {
+    *out << type->symbol << "\t" << x.x[0] << "\t" << x.x[1] << "\t" << x.x[2] << "\t" << endl;
+    return true;
+  } else
+    return false;
 };
 
 ostream & operator << (ostream &ost, const atom &a)
 {
-	ost << "[" << a.Name << "|" << &a << "]";
-	return ost;
+  ost << "[" << a.Name << "|" << &a << "]";
+  return ost;
 };
 
@@ -101,13 +120,13 @@
 bool atom::Compare(const atom &ptr)
 {
-	if (nr < ptr.nr)
-		return true;
-	else
-		return false;
+  if (nr < ptr.nr)
+    return true;
+  else
+    return false;
 };
 
 bool operator < (atom &a, atom &b)
 {
-	return a.Compare(b);
+  return a.Compare(b);
 };
 
Index: src/bond.cpp
===================================================================
--- src/bond.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/bond.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -14,14 +14,14 @@
 bond::bond()
 {
-	leftatom = NULL;
-	rightatom = NULL;
-	previous = NULL;
-	next = NULL;
-	nr = -1;
-	HydrogenBond = 0;
-	BondDegree = 0;
-	Used = white;
-	Cyclic = false;
-	Type = Undetermined;
+  leftatom = NULL;
+  rightatom = NULL;
+  previous = NULL;
+  next = NULL;
+  nr = -1;
+  HydrogenBond = 0;
+  BondDegree = 0;
+  Used = white;
+  Cyclic = false;
+  Type = Undetermined;
 };
 
@@ -34,37 +34,37 @@
 bond::bond(atom *left, atom *right, int degree=1, int number=0)
 {
-	leftatom = left;
-	rightatom = right;
-	previous = NULL;
-	next = NULL;
-	HydrogenBond = 0;
-	if ((left != NULL) && (right != NULL)) {
-		if ((left->type != NULL) && (left->type->Z == 1))
-			HydrogenBond++;
-		if ((right->type != NULL) && (right->type->Z == 1))
-			HydrogenBond++;
-	}
-	BondDegree = degree;
-	nr = number;
-	Used = white;
-	Cyclic = false;
+  leftatom = left;
+  rightatom = right;
+  previous = NULL;
+  next = NULL;
+  HydrogenBond = 0;
+  if ((left != NULL) && (right != NULL)) {
+    if ((left->type != NULL) && (left->type->Z == 1))
+      HydrogenBond++;
+    if ((right->type != NULL) && (right->type->Z == 1))
+      HydrogenBond++;
+  }
+  BondDegree = degree;
+  nr = number;
+  Used = white;
+  Cyclic = false;
 };
 bond::bond(atom *left, atom *right)
 {
-	leftatom = left;
-	rightatom = right;
-	previous = NULL;
-	next = NULL;
-	HydrogenBond = 0;
-	if ((left != NULL) && (right != NULL)) {
-		if ((left->type != NULL) && (left->type->Z == 1))
-			HydrogenBond++;
-		if ((right->type != NULL) && (right->type->Z == 1))
-			HydrogenBond++;
-	}
-	BondDegree = 1;
-	nr = 0;
-	Used = white;
-	Cyclic = false;
+  leftatom = left;
+  rightatom = right;
+  previous = NULL;
+  next = NULL;
+  HydrogenBond = 0;
+  if ((left != NULL) && (right != NULL)) {
+    if ((left->type != NULL) && (left->type->Z == 1))
+      HydrogenBond++;
+    if ((right->type != NULL) && (right->type->Z == 1))
+      HydrogenBond++;
+  }
+  BondDegree = 1;
+  nr = 0;
+  Used = white;
+  Cyclic = false;
 };
 
@@ -73,17 +73,17 @@
 bond::~bond()
 {
-	// remove this node from the list structure
-	if (previous != NULL) {
-		previous->next = next;
-	}
-	if (next != NULL) {
-		next->previous = previous;
-	}
+  // remove this node from the list structure
+  if (previous != NULL) {
+    previous->next = next;
+  }
+  if (next != NULL) {
+    next->previous = previous;
+  }
 };
 
-ostream & operator << (ostream &ost, bond &b) 
+ostream & operator << (ostream &ost, const bond &b) 
 {
-	ost << "[" << b.leftatom->Name << " <" << b.BondDegree << "(H" << b.HydrogenBond << ")>" << b.rightatom->Name << "]";
-	return ost;
+  ost << "[" << b.leftatom->Name << " <" << b.BondDegree << "(H" << b.HydrogenBond << ")>" << b.rightatom->Name << "]";
+  return ost;
 };
 
@@ -94,9 +94,10 @@
 atom * bond::GetOtherAtom(atom *Atom) const
 {
-	if(leftatom == Atom) 
-		return rightatom;
-	if(rightatom == Atom) 
-		return leftatom;
-	return NULL;
+  if(leftatom == Atom) 
+    return rightatom;
+  if(rightatom == Atom) 
+    return leftatom;
+  cerr << "Bond " << *this << " does not contain atom " << *Atom << "!" << endl;
+  return NULL;
 };
 
@@ -107,5 +108,5 @@
 bond * bond::GetFirstBond()
 {
-	return GetFirst(this);
+  return GetFirst(this);
 };
 
@@ -116,5 +117,5 @@
 bond * bond::GetLastBond()
 {
-	return GetLast(this);
+  return GetLast(this);
 };
 
@@ -124,5 +125,5 @@
 enum Shading bond::IsUsed() 
 {
-	return Used;
+  return Used;
 };
 
@@ -133,5 +134,5 @@
 bool bond::Contains(const atom *ptr)
 {
-	return ((leftatom == ptr) || (rightatom == ptr));
+  return ((leftatom == ptr) || (rightatom == ptr));
 };
 
@@ -142,5 +143,5 @@
 bool bond::Contains(const int number)
 {
-	return ((leftatom->nr == number) || (rightatom->nr == number));
+  return ((leftatom->nr == number) || (rightatom->nr == number));
 };
 
@@ -149,11 +150,11 @@
  */
 bool bond::MarkUsed(enum Shading color) {
-	if (Used == black) {
-		cerr << "ERROR: Bond " << this << " was already marked black!." << endl;
-		return false;
-	} else {
-		Used = color;
-		return true;
-	}
+  if (Used == black) {
+    cerr << "ERROR: Bond " << this << " was already marked black!." << endl;
+    return false;
+  } else {
+    Used = color;
+    return true;
+  }
 };
 
@@ -162,4 +163,4 @@
  */
 void bond::ResetUsed() {
-	Used = white;
+  Used = white;
 };
